Update StatementDefinition - m3ter Documentation

Update StatementDefinition

cURL

curl --request PUT \
  --url https://api.m3ter.com/organizations/{orgId}/statementdefinitions/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "version": 123,
  "name": "<string>",
  "includePricePerUnit": true,
  "dimensions": [
    {
      "name": "<string>",
      "filter": [
        "<string>"
      ],
      "meterId": "<string>",
      "attributes": [
        "<string>"
      ]
    }
  ],
  "measures": [
    {
      "meterId": "<string>",
      "name": "<string>",
      "aggregations": []
    }
  ],
  "generateSlimStatements": true
}
'

Python

import requests

url = "https://api.m3ter.com/organizations/{orgId}/statementdefinitions/{id}"

payload = {
    "version": 123,
    "name": "<string>",
    "includePricePerUnit": True,
    "dimensions": [
        {
            "name": "<string>",
            "filter": ["<string>"],
            "meterId": "<string>",
            "attributes": ["<string>"]
        }
    ],
    "measures": [
        {
            "meterId": "<string>",
            "name": "<string>",
            "aggregations": []
        }
    ],
    "generateSlimStatements": True
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)

JavaScript

const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    version: 123,
    name: '<string>',
    includePricePerUnit: true,
    dimensions: [
      {
        name: '<string>',
        filter: ['<string>'],
        meterId: '<string>',
        attributes: ['<string>']
      }
    ],
    measures: [{meterId: '<string>', name: '<string>', aggregations: []}],
    generateSlimStatements: true
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/statementdefinitions/{id}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/statementdefinitions/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "", 
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'version' => 123,
    'name' => '<string>',
    'includePricePerUnit' => true,
    'dimensions' => [
        [
                'name' => '<string>',
                'filter' => [
                                '<string>'
                ],
                'meterId' => '<string>',
                'attributes' => [
                                '<string>'
                ]
        ]
    ],
    'measures' => [
        [
                'meterId' => '<string>',
                'name' => '<string>',
                'aggregations' => []
        ]
    ],
    'generateSlimStatements' => true
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Response Structure

{
  "id": "<string>",
  "version": 123,
  "name": "<string>",
  "includePricePerUnit": true,
  "dimensions": [
    {
      "name": "<string>",
      "filter": ["<string>"],
      "meterId": "<string>",
      "attributes": ["<string>"]
    }
  ],
  "measures": [
    {
      "meterId": "<string>",
      "name": "<string>",
      "aggregations": []
    }
  ],
  "generateSlimStatements": true,
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>"
}

Error Messages

{
  "message": "<string>"
}